# -*- coding: iso-8859-1 -*-
"""
Programme du couplage entre HOMARD et Code_Aster
"""
__revision__ = "V2.8"
#
import os
#
from aster_homard_utilitaires   import exec_commande
#
########################## Debut de la fonction ##################################
#
def aster_homard_3 (dict_arguments, variables_conf, message_info) :
#
  """
   Arguments :
     1. Dictionnaire des arguments generaux
     2. Dictionnaire des variables de configuration
     3. message_info : les messages d'information a completer
  """
#
# 1. code de retour :
  blabla = "\nDans " + __name__ + " :"
  messages_erreur = { 0 : "",
                      1 : "Probleme a l'execution de HOMARD" }
  code_erreur = 0
  code_retour_exec = 0
  message_erreur = ""
#
#  print blabla, "\ndict_arguments :", dict_arguments, "\nvariables_conf :", variables_conf
#
  verbose = dict_arguments["verbose"]
  fic_donn = dict_arguments["fic_donn"]
#
# 2. Reperage de l'executable
#
  executable = dict_arguments["executable"]
#
# 3. Lancement
#
  if not code_erreur :
    commande = executable
    modehoma = variables_conf["ModeHOMA"]
    if modehoma == 2 :
      commande = commande + "<" + fic_donn
      if not verbose :
        commande = commande + "> /dev/null"
    if verbose :
      message_info += ".. Appel systeme pour " + commande
    code_retour_exec, saux = exec_commande (commande, verbose)
    if code_retour_exec :
      code_retour_exec = max(10, code_retour_exec)
#
# 4. La fin
#
  if code_erreur :
    message_erreur += messages_erreur[code_erreur]
  elif code_retour_exec:
    message_erreur += saux
    message_erreur += messages_erreur[1]
  else :
    message_erreur = ""
#
  return code_erreur, code_retour_exec, message_info, message_erreur
#
##########################  Fin de la fonction  ##################################
#
##########################       Auto-test      ##################################
#
if __name__ == '__main__' :
#
  from aster_homard_utilitaires import verif
#
  e1 = {"fic_conf" : "HOMARD.Configuration" }
  a1 = {"fic_donn" : "DONN", 'PERSO': "non", 'rep_refe_LOGICIEL': '/logiciels/HOMARD/HOMARD_PUBLIC'}
  v1 = {'ModeHOMA': 2 }
  l1_refe = 10
  l1_calc = aster_homard_3 (e1, a1, v1)
  verif ("Test sur l1", l1_refe, l1_calc)
#
  e2 = {"fic_conf" : "HOMARD.Configuration" }
  a2 = {"fic_donn" : "DONN", 'PERSO': "non", 'rep_refe_LOGICIEL': '/logiciefou/HOMOMARD_PUBLIC'}
  v2 = {'ModeHOMA': 2 }
  l2_refe = 3
  l2_calc = aster_homard_3 (e2, a2, v2)
  verif ("Test sur l2", l2_refe, l2_calc)
#
  fic_conf_test = "HOMARD.Configuration"
  fichier_test = open (fic_conf_test, 'w')
  s = "ModeHOMA 1\n"
  fichier_test.write(s)
  fichier_test.close()
  e3 = {"fic_conf" : fic_conf_test }
  a3 = {"fic_donn" : "DONN", 'PERSO': "oui", 'rep_pers_LOGICIEL': '/local/HOMARD'}
  v3 = {'ModeHOMA': 1 }
  l3_refe = 10
  l3_calc = aster_homard_3 (e3, a3, v3)
  verif ("Test sur l3", l3_refe, l3_calc)
  os.remove(fic_conf_test)
  os.remove("core")
