# -*- coding: iso-8859-1 -*-
"""
Programme du couplage entre HOMARD et Code_Aster
Copie des fichiers d'echange pour le deboggage ulterieur
Copie avant ou apres adaptation
"""
__revision__ = "V2.2"
#
import os
import string
import shutil
#
from aster_homard_utilitaires   import int_to_str2
#
########################## Debut de la fonction ##################################
#
def aster_homard_6 (environnement, dict_arguments, variables_conf, quand, message_info) :
#
  """
   Arguments :
     1. Dictionnaire de l'environnement
     2. Dictionnaire des arguments generaux
     3. Dictionnaire des variables de configuration
     4. quand : "av" ou "ap" pour connaitre le moment de la copie
     5. message_info : les messages d'information a completer
  """
#
# 1. code de retour :
  blabla = "\nDans " + __name__ + " :"
  code_erreur = 0
  message_erreur = ""
#
  fic_conf = environnement["fic_conf"]
#
###  print blabla, dict_arguments, variables_conf
  verbose = dict_arguments["verbose"]
  rep_debug = dict_arguments ["rep_debug"]
###  print "glop rep_debug = ",rep_debug
  rep_calc_logiciel = dict_arguments ["rep_calc_LOGICIEL"]
###  print "glop rep_calc_logiciel =",rep_calc_logiciel
  modehoma = variables_conf["ModeHOMA"]
#
  niter = string.atoi(variables_conf["NumeIter"])
  aux_niter = int_to_str2(niter)
#
  niterp1 = niter + 1
  aux_niterp1 = int_to_str2(niterp1)
#
  CCMaiN___fic = variables_conf["CCMaiN___fic"]
  CCMaiN___fic_rep = None
  if len(os.path.dirname(CCMaiN___fic)) > 0 :
    CCMaiN___fic_rep = os.path.dirname(CCMaiN___fic)
#
  CCMaiNP1_fic = None
  if ( variables_conf.has_key("CCMaiNP1_fic") ) :
    CCMaiNP1_fic = variables_conf["CCMaiNP1_fic"]
    if len(os.path.dirname(CCMaiNP1_fic)) > 0 :
      CCMaiNP1_fic_rep = os.path.dirname(CCMaiNP1_fic)
#
  CCIndica_fic = None
  if ( variables_conf.has_key("CCIndica_fic") ) :
    CCIndica_fic = variables_conf["CCIndica_fic"]
    if len(os.path.dirname(CCIndica_fic)) > 0 :
      CCIndica_fic_rep = os.path.dirname(CCIndica_fic)
#
  HOMaiN___fic = variables_conf["HOMaiN___fic"]
  HOMaiN___fic_rep = None
  if len(os.path.dirname(HOMaiN___fic)) > 0 :
    HOMaiN___fic_rep = os.path.dirname(HOMaiN___fic)
#
  HOMaiNP1_fic = None
  if ( variables_conf.has_key("HOMaiNP1_fic") ) :
    HOMaiNP1_fic = variables_conf["HOMaiNP1_fic"]
    if len(os.path.dirname(HOMaiNP1_fic)) > 0 :
      HOMaiNP1_fic_rep = os.path.dirname(HOMaiNP1_fic)
#
  executable = dict_arguments["executable"]
#
  if verbose :
    print blabla
#
  while not code_erreur :
#
# 2. Donnees pour les informations
# 2.1. Liste des fichiers
#
#gn    print os.listdir(rep_calc_logiciel)
    if quand == "av" :
      l_aux = [ CCMaiN___fic ]
      if ( CCIndica_fic is not None and CCIndica_fic != CCMaiN___fic ) :
        l_aux.append(CCIndica_fic)
      if niter > 0 :
        l_aux.append(HOMaiN___fic)
      if modehoma == 2 :
        l_aux.append("HOMARD.Donnees")
    elif quand == "ap" :
      l_aux = [ CCMaiNP1_fic, HOMaiNP1_fic ]
    else :
      l_aux = [ ]
#
# 2.2. Copie effective
#
    for fic in l_aux :
      if os.path.isfile(fic) :
        if ( fic == "HOMARD.Donnees" ) :
          saux = "donn."+aux_niter+".info"
        else :
          saux = os.path.basename(fic)
        fic_2 = os.path.join(rep_debug, saux)
        try :
          shutil.copyfile(fic, fic_2)
        except os.error, erreur_partiel :
          message_erreur  = "Copie de " + fic + " dans " + fic_2
          message_erreur += "\nErreur numero " + str(erreur_partiel[0]) + " : " + str(erreur_partiel[1])
          code_erreur = 31
          break
#
# 2.3. Ajout de donnees bidon pour les futures informations
#
    if modehoma == 1 :
      ligne = "0\n0\nq\n"
      if niter == 0 :
        l_aux = [ "00.info" ]
      else :
        l_aux = [ aux_niter + ".info_avant" ]
      l_aux.append( aux_niterp1 + ".info_apres" )
      for suffixe in l_aux :
        fic = os.path.join(rep_debug, "donn."+suffixe)
        fichier = open (fic, "w")
        fichier.write(ligne)
        fichier.close()
#
# 3. Fichier de configuration
#
    fic = os.path.join(rep_calc_logiciel, fic_conf)
    fichier = open (fic, "r")
    les_lignes = fichier.readlines()
    #print "les_lignes =\n", les_lignes
    fichier.close()
#
    les_lignes_bis = []
    if modehoma == 2 :
      saux = "."+aux_niter+".info"
    else :
      saux = "."+aux_niter+".vers."+aux_niterp1
    fic_2 = os.path.join(rep_debug, fic_conf+saux)
    fic = os.path.join(rep_debug, fic_2)
    fichier = open (fic, "w")
##    print "CCMaiN___fic = ", CCMaiN___fic
##    print "CCMaiN___fic_rep = ", CCMaiN___fic_rep
    for ligne in les_lignes :
      ligne_bis = ligne
      aux1 = None
##      print ligne, ligne.find(CCMaiNP1_fic)
      if ( ligne.find(rep_calc_logiciel) >= 0 ) :
        aux1 = rep_calc_logiciel
        aux2 = "."
      elif ( ligne.find(CCMaiN___fic) >= 0 ) :
        aux1 = CCMaiN___fic_rep
        aux2 = rep_debug
      elif ( CCMaiNP1_fic is not None ) :
        if ( ligne.find(CCMaiNP1_fic) >= 0 ) :
          aux1 = os.path.join(CCMaiNP1_fic_rep, CCMaiNP1_fic)
          aux2 = os.path.join(rep_debug, "maill."+aux_niterp1+".med" )
      elif ( CCIndica_fic is not None ) :
        if ( ligne.find(CCIndica_fic) >= 0 ) :
          aux1 = CCIndica_fic_rep
          aux2 = rep_debug
      elif ( ligne.find(HOMaiN___fic) >= 0 ) :
        aux1 = HOMaiN___fic_rep
        aux2 = rep_debug
      elif ( HOMaiNP1_fic is not None ) :
        if ( ligne.find(HOMaiNP1_fic) >= 0 ) :
          aux1 = os.path.join(HOMaiNP1_fic_rep, HOMaiNP1_fic)
          aux2 = os.path.join(rep_debug, "maill."+aux_niterp1+".med" )
      if ( aux1 is not None ) :
        ligne_bis = ligne.replace(aux1, aux2)
      les_lignes_bis.append(ligne_bis)
      fichier.write(ligne_bis)
    fichier.close()
    #print "les_lignes_bis =\n", les_lignes_bis
#
#   Ajout de fichiers de configuration pour les futures informations
    if modehoma == 1 :
      if niter == 0 :
        l_aux = [ "00.info" ]
      else :
        l_aux = [ aux_niter + ".info_avant" ]
      l_aux.append( aux_niterp1 + ".info_apres" )
      for suffixe in l_aux :
        fic = os.path.join(rep_debug, fic_conf+"."+suffixe)
        fichier = open (fic, "w")
        for ligne in les_lignes_bis :
          ligne_bis = ligne
          aux1 = None
          #print ligne
          if ( "ModeHOMA" in ligne ) :
            ligne_bis = "ModeHOMA 2\n"
          elif ( "ListeStd" in ligne ) :
            ligne_bis = "ListeStd Liste."+suffixe+"\n"
          if ( suffixe != "00.info" ) :
            if ( "CCAssoci" in ligne ) :
              ligne_bis = "CCAssoci HOMARD\n"
          if ( suffixe == aux_niterp1+".info_apres" ) :
            if ( "HOMaiN__" in ligne ) :
              ligne_bis = "#\n"
            elif ( "HOMaiNP1" in ligne ) :
              ligne_bis = ligne.replace("HOMaiNP1", "HOMaiN__")
          else :
            if ( "HOMaiNP1" in ligne ) :
              ligne_bis = "#\n"
          fichier.write(ligne_bis)
        fichier.close()
#
# 4. Variables annexes
#
    if os.environ.has_key("MED_HOME") :
      MED_HOME = os.environ ["MED_HOME"]
    else :
      MED_HOME = os.environ ["HOME"]
    mdump = os.path.join(MED_HOME, "Linux64", "mdump")
#
# 5. Makefile
#
    fic = os.path.join(rep_debug, "Makefile")
    fichier = open (fic, "w")
#
# 5.1. En-tete
#
    makefile_t1  = "REP_LOCAL = " + rep_debug + "\n"
    makefile_t1 += "EXEC = " + executable + "\n"
    makefile_t1 += "MDUMP = " + mdump + "\n"
    makefile_t1 += "MODE_DUMP_HO = -nodump_ho\n"
    makefile_t1 += "NOMFIC_DONN_MED_DUMP = $(REP_LOCAL)/donn\n"
    makefile_t1 += "NOMFIC_DONN_HOMMED_DUMP = $(REP_LOCAL)/donnd\n"
    makefile_t1 += "NOMFIC_DONN_HOMMED_DUMP = $(REP_LOCAL)/donn\n"
#
    for ligne in makefile_t1 :
      fichier.write(ligne)
#
# 5.2. Indexation generale
#
    ligne = "#\n"
    ligne += "all :"
    for naux in range(niterp1) :
      auxd = int_to_str2(naux)
      auxf = int_to_str2(naux+1)
      if naux == 0 :
        ligne += " 00.info"
      else :
        ligne += " " + auxd + ".info_avant"
      ligne += " " + auxd + ".vers." + auxf + " " + auxf + ".info_apres"
    ligne += "\n#\n"
    fichier.write(ligne)
#
# 5.3. Chacune des iterations
#
    ligne = "#\n"
#
    for naux in range(niterp1) :
      auxd = int_to_str2(naux)
      auxf = int_to_str2(naux+1)
      if naux == 0 :
        ligne += "00.info :\n"
        ligne += "\t@ /bin/cp $(REP_LOCAL)/" + fic_conf + ".00.info $(REP_LOCAL)/" + fic_conf + "\n"
        ligne += "\ttime $(EXEC) < $(REP_LOCAL)/donn.00.info\n"
      else :
        ligne += auxd + ".info_avant :\n"
        ligne += "\t@ /bin/cp $(REP_LOCAL)/" + fic_conf + "." + auxd + ".info_avant $(REP_LOCAL)/" + fic_conf + "\n"
        ligne += "\ttime $(EXEC) < $(REP_LOCAL)/donn." + auxd + ".info_avant\n"
      ligne += "#\n"
      ligne += auxd + ".vers." + auxf + " :\n"
      ligne += "\t@ /bin/cp $(REP_LOCAL)/" + fic_conf + "." + auxd + ".vers." + auxf + " $(REP_LOCAL)/" + fic_conf + "\n"
      ligne += "\ttime $(EXEC)\n"
      ligne += "\tif test -f $(REP_LOCAL)/maill." + auxf + ".med ; then $(MDUMP) $(REP_LOCAL)/maill." + auxf + ".med > $(REP_LOCAL)/maill." + auxf + ".med.dump < $(NOMFIC_DONN_MED_DUMP) ; fi\n"
      ligne += "\tif test $(MODE_DUMP_HO) = '-dump_ho' ; then if test -f $(REP_LOCAL)/maill." + auxf + ".hom.med ; then $(MDUMP) $(REP_LOCAL)/maill." + auxf + ".hom.med > $(REP_LOCAL)/maill." + auxf + ".hom.med.dump < $(NOMFIC_DONN_HOMMED_DUMP) ; fi ; fi\n"
      if naux == 0 :
        ligne += "\tif test $(MODE_DUMP_HO) = '-dump_ho' ; then if test -f $(REP_LOCAL)/maill.00.hom.med ; then $(MDUMP) $(REP_LOCAL)/maill.00.hom.med > $(REP_LOCAL)/maill.00.hom.med.dump < $(NOMFIC_DONN_HOMMED_DUMP) ; fi ; fi\n"
      ligne += "#\n"
      ligne += auxf + ".info_apres :\n"
      ligne += "\t@ /bin/cp $(REP_LOCAL)/" + fic_conf + "." + auxf + ".info_apres $(REP_LOCAL)/" + fic_conf + "\n"
      ligne += "\ttime $(EXEC) < $(REP_LOCAL)/donn." + auxf + ".info_apres\n"
      ligne += "#\n"
    ligne += "\n#\n"
    fichier.write(ligne)
#
    fichier.close()
#
#
#
    break
#
# 6. La fin
#
  return code_erreur, message_info, message_erreur
#
##########################  Fin de la fonction  ##################################
#
##########################       Auto-test      ##################################
#
if __name__ == '__main__' :
#
  from aster_homard_utilitaires import verif
#
  e1 = { "fic_donn" : "DONN", "fic_conf" : "HOMARD.Configuration" }
  a1 = {'PERSO': "non", 'nivinf': 2 }
  v1 = {'NumeIter': '3', 'PPBasFic': 'INFO', 'ModeHOMA': 2, 'ListeStd': 'aster_homard_5.py' }
  l1_refe = 0
  l1_calc = aster_homard_6 (e1, a1, v1, 0)
  verif ("Test sur l1", l1_refe, l1_calc)
#
  fic_conf_test = "HOMARD.Configuration"
  fichier_test = open (fic_conf_test, "w")
  s = "ModeHOMA 1\n"
  fichier_test.write(s)
  fichier_test.close()
  e2 = { "fic_donn" : "DONN", "fic_conf" : fic_conf_test }
  a2 = {'PERSO': "oui", 'nivinf': 1 }
  v2 = {'NumeIter': '3', 'PPBasFic': 'INFO', 'ModeHOMA': 2, 'ListeStd': 'gabuzome' }
  l2_refe = 0
  l2_calc = aster_homard_6 (e2, a2, v2, 8)
  verif ("Test sur l2", l2_refe, l2_calc)
  os.remove(fic_conf_test)
  os.remove(fic_conf_test+".3.info")
